import { baseUrl } from "./config.js";
import { getHttp, postHttp } from "./request.js";
import { Reports } from "./modules/Reports";
import { activity } from "./modules/activity";
import { Home } from "./modules/Home";
import { User } from "./modules/User";
import { Report } from "./modules/ReportArticle";

export { Reports, activity, Home, User, Report };

/* 上传 */
export const uploadurl = baseUrl + "/resource/image/upload";
// 校验token接口
export const checkToken = (params) => {
  return getHttp("/user/check/status", params, 0);
};

/* 个人中心 */
export const Mine = {
  /* 我的收藏列表 PageSize CurrentIndex  */
  getCollect: (params) => {
    return getHttp("/user/collect/list", params);
  },
  /* 用户信息 */
  getInfo: (params) => {
    return getHttp("/user/detail", params, 0);
  },
  /* 获取访谈列表 PageSize CurrentIndex*/
  getInterview: (params) => {
    return getHttp("/user/interview/apply/list", params);
  },
  /* 获取浏览历史 */
  getHistory: (params) => {
    return getHttp("/user/browse/history/list", params);
  },
  /* 优化建议 */
  advice: (params) => {
    return postHttp("/advice/add", params);
  },
};
/* 搜索 */
export const Search = {
  /* 获取搜索推荐词 */
  getKeys: (params) => {
    return getHttp("/config/detail", params, 0);
  },
  /* 搜索  KeyWord */
  getResult: (params) => {
    return getHttp("/search/list", params, 0);
  },
  /* 报告搜索  KeyWord */
  getResultReport: (params) => {
    return getHttp("/search/report/list", params, 0);
  },
  /* 报告 KeyWord 素材库*/
  getArtAndChartList: (params) => {
    return getHttp("/search/artAndChart/listPage", params, 0);
  },
};
/* 图标 */
export const Chart = {
  /*图表标签分类接口*/
  getChartPatg: (params) => {
    return getHttp("/chart/patg", params);
  },
  /*我的收藏接口*/
  getChartcollection: (params) => {
    return getHttp("/chart/my/collection", params);
  },
  /*删除我的收藏接口*/
  myChartCollect: (params) => {
    return postHttp("/chart/collect", params);
  },
  /*图表的详情*/
  myChartDetail: (params) => {
    return getHttp("/chart/detail", params);
  },
  /*图表的详情*/
  myChartTop: (params) => {
    return postHttp("/chart/top", params);
  },
};

/* 研选 */
export const Research = {
  /* 近期更新主题列表接口 */
  researchNewList: (params) => {
    return getHttp("/research/theme/newList", params, 0);
  },
  /* 用户收藏列表接口 */
  researchCollectionList: (params) => {
    return getHttp("/research/collectionList", params, 0);
  },
  /* 主题热度/近期更新更多,列表接口 */
  researchHotList: (params) => {
    return getHttp("/research/hotList", params, 0);
  },
  /* KOL榜列表接口 */
  researchKolList: (params) => {
    return getHttp("/research/kolList", params, 0);
  },
  /* 研选作者详情接口 */
  departmentIdDetail: (params) => {
    return getHttp("/research/departmentId/detail", params, 0);
  },
  /* 研选作者详情接口 */
  researchThemeDetail: (params) => {
    return getHttp("/research/theme/detail", params, 0);
  },
  /* 热搜关键词接口 */
  researchHotKeyWord: (params) => {
    return getHttp("/research/hotKeyWord", params, 0);
  },
};

/* 免费送月卡 */
export const FreeButton = {
  /*获取是否展示免费试用按钮接口*/
  userIsShowFreeButton: (params) => {
    return getHttp("/user/isShow/freeButton", params, 0);
  },
  /* 隐藏当天的按钮接口 */
  userFreeButtonUpdate: (params) => {
    return postHttp("/user/freeButton/update", params, 0);
  },
  /*分享的时候判断是不是弘则的手机号*/
  userIsShowShare: (params) => {
    return getHttp("/user/isShow/share", params, 0);
  },
  /*获取权限弹窗是否展示免费月卡接口*/
  userIsShowAlert: (params) => {
    return getHttp("/user/isShow/alert", params, 0);
  },
  /*获取权限弹窗是否展示免费月卡接口*/
  wechatShareImage: (params) => {
    return postHttp("/wechat/shareImage", params, 0);
  },
};
